import React, { useCallback, useEffect, useMemo, useRef, useState } from 'react'
import styles from './index.module.scss'
import { E2InputKeyType, TypeE2Form } from './type'
import { useDispatch, useSelector } from 'react-redux'
import { E2_APIdel, E2_APIgetList } from '@/store/action/E2damaged'
import { MessageFu } from '@/utils/message'
import history, { btnFlagFu } from '@/utils/history'
import { FourTableType } from '@/pages/B_enterTibet/B1collect/type'
import { Button, DatePicker, Input, Select } from 'antd'
import MyPopconfirm from '@/components/MyPopconfirm'
import { RootState } from '@/store'
import dayjs from 'dayjs'
import { E2tableC, statusObj } from '@/utils/tableData'
import ExportJsonExcel from 'js-export-excel'
import { B3_4inputKeyArr } from '@/pages/B_enterTibet/B1collect/data'
import { selectObj } from '@/utils/select'
import MyTable from '@/components/MyTable'
const { RangePicker } = DatePicker

export const E2baseFormData: TypeE2Form = {
  pageSize: 10,
  pageNum: 1,
  num: '',
  name: '',
  deptName: '',
  userName: '',
  startTime: '',
  endTime: '',
  status: null,
  userType: null,
  storageName: '',
  checkNum: ''
}

function E2damaged() {
  const dispatch = useDispatch()

  const [formData, setFormData] = useState(E2baseFormData)
  const formDataRef = useRef(E2baseFormData)
  const formDataOldRef = useRef(E2baseFormData)

  useEffect(() => {
    formDataRef.current = formData
  }, [formData])

  // 点击搜索的 时间戳
  const [timeKey, setTimeKey] = useState(0)

  // 点击搜索
  const clickSearch = useCallback(() => {
    setFormData({ ...formData, pageNum: 1 })
    setTimeout(() => {
      setTimeKey(Date.now())
    }, 50)
  }, [formData])

  // 时间选择器改变
  const timeChange = useCallback(
    (date: any, dateString: any) => {
      let startTime = ''
      let endTime = ''
      if (dateString[0] && dateString[1]) {
        startTime = dateString[0] + ' 00:00:00'
        endTime = dateString[1] + ' 23:59:59'
      }
      setFormData({ ...formData, startTime, endTime })
    },
    [formData]
  )
  // 封装发送请求的函数
  const getListFu = useCallback(() => {
    formDataOldRef.current = { ...formDataRef.current }
    dispatch(E2_APIgetList(formDataRef.current))
  }, [dispatch])

  useEffect(() => {
    getListFu()
  }, [getListFu, timeKey])

  // 输入框的改变
  const txtChangeFu = useCallback(
    (txt: string, key: E2InputKeyType) => {
      setFormData({
        ...formData,
        [key]: txt
      })
    },
    [formData]
  )

  // 点击重置
  const resetSelectFu = useCallback(() => {
    setFormData(E2baseFormData)
    setTimeout(() => {
      setTimeKey(Date.now())
    }, 50)
  }, [])

  // 页码变化
  const paginationChange = useCallback(
    (pageNum: number, pageSize: number) => {
      setFormData({ ...formData, pageNum, pageSize })
      setTimeout(() => {
        setTimeKey(Date.now())
      }, 50)
    },
    [formData]
  )

  // 点击删除
  const delTableFu = useCallback(
    async (id: number) => {
      const res = await E2_APIdel(id)
      if (res.code === 0) {
        MessageFu.success('删除成功')
        getListFu()
      }
    },
    [getListFu]
  )

  // 点击操作按钮
  const tableBtnFu = useCallback((id: number, key: string) => {
    history.push(`/damaged_edit/${key}/${id}`)
  }, [])

  const tableLastBtn = useMemo(() => {
    return [
      {
        title: '操作',
        render: (item: FourTableType) => {
          let obj = btnFlagFu(item)
          return !Object.values(obj).some(Boolean) ? (
            '-'
          ) : (
            <>
              {obj['编辑'] ? (
                <Button size='small' type='text' onClick={() => tableBtnFu(item.id, '2')}>
                  编辑
                </Button>
              ) : null}

              {obj['审批'] ? (
                <Button size='small' type='text' onClick={() => tableBtnFu(item.id, '3')}>
                  审批
                </Button>
              ) : null}
              {obj['查看'] ? (
                <Button size='small' type='text' onClick={() => tableBtnFu(item.id, '4')}>
                  查看
                </Button>
              ) : null}

              {obj['删除'] ? (
                <MyPopconfirm txtK='删除' onConfirm={() => delTableFu(item.id)} />
              ) : null}
            </>
          )
        }
      }
    ]
  }, [delTableFu, tableBtnFu])

  // 从仓库拿数据
  const tableInfo = useSelector((state: RootState) => state.E2damaged.tableInfo)

  // 点击导出
  const deriveFu = useCallback(async () => {
    const name = '残损登记' + dayjs(new Date()).format('YYYY-MM-DD HH:mm')

    const res = await E2_APIgetList(
      {
        ...formDataOldRef.current,
        pageNum: 1,
        pageSize: 99999
      },
      true
    )

    if (res.code === 0) {
      if (res.data.records.length <= 0) return MessageFu.warning('当前搜索条件没有数据!')

      const option = {
        fileName: name,
        datas: [
          {
            sheetData: res.data.records.map((v: FourTableType) => ({
              ...v,
              status: statusObj[v.status as 1]
            })),
            sheetName: name,
            sheetFilter: [
              'num',
              'name',
              'storageName',
              'deptName',
              'creatorName',
              'createTime',
              'status',
              // 待完善
              'xxxxx'
            ],
            sheetHeader: [
              '业务单号',
              '申请名称',
              '关联库房',
              '发起部门',
              '发送人',
              '发起日期',
              '申请状态',
              '相关盘点'
            ],
            columnWidths: [10, 10, 10, 10, 10, 10, 10]
          }
        ]
      }

      const toExcel = new ExportJsonExcel(option) //new
      toExcel.saveExcel() //保存
    }
  }, [])

  return (
    <div className={styles.E2damaged}>
      <div className='pageTitle'>残损登记</div>
      <div className='D4top D4top0'>
        <div className='D4topll'>
          {B3_4inputKeyArr.map(item => (
            <div key={item.name}>
              <span>{item.name}：</span>
              <Input
                placeholder={`请输入${item.name}`}
                maxLength={30}
                value={formData[item.key]}
                onChange={e => txtChangeFu(e.target.value, item.key)}
              />
            </div>
          ))}
          <div>
            <span>库房名称：</span>
            <Input
              placeholder={`请输入库房名称`}
              maxLength={30}
              value={formData.storageName}
              onChange={e => txtChangeFu(e.target.value, 'storageName')}
            />
          </div>
        </div>
        <div className='D4toprr'>
          <Button type='primary' onClick={deriveFu}>
            批量导出
          </Button>
          &emsp;
          <Button type='primary' onClick={() => history.push('/damaged_edit/1/null')}>
            新增
          </Button>
        </div>
      </div>
      <div className='D4top'>
        <div className='D4topll'>
          <div>
            <span>发起日期范围：</span>
            <RangePicker
              value={
                formData.startTime ? [dayjs(formData.startTime), dayjs(formData.endTime)] : null
              }
              onChange={timeChange}
            />
          </div>

          <div>
            <span>申请状态：</span>
            <Select
              allowClear={true}
              placeholder='全部'
              style={{ width: 150 }}
              value={formData.status}
              onChange={e => setFormData({ ...formData, status: e })}
              options={selectObj['申请状态'].filter(v => v.label !== '待盘点')}
            />
          </div>

          <div>
            <span>选择角色：</span>
            <Select
              allowClear={true}
              style={{ width: 150 }}
              placeholder='全部'
              options={selectObj['角色']}
              // fieldNames={{ value: 'id', label: 'roleName' }}
              value={formData.userType}
              onChange={e => setFormData({ ...formData, userType: e })}
            />
          </div>

          <div>
            <span>盘点编码：</span>
            <Input
              placeholder={`请输入盘点编码`}
              maxLength={30}
              value={formData.checkNum}
              onChange={e => txtChangeFu(e.target.value, 'checkNum')}
            />
          </div>
        </div>
        <div className='D4toprr'>
          <Button type='primary' onClick={clickSearch}>
            查询
          </Button>
          &emsp;<Button onClick={resetSelectFu}>重置</Button>
        </div>
      </div>

      {/* 表格 */}
      <MyTable
        yHeight={610}
        list={tableInfo.list}
        columnsTemp={E2tableC}
        lastBtn={tableLastBtn}
        pageNum={formData.pageNum}
        pageSize={formData.pageSize}
        total={tableInfo.total}
        onChange={(pageNum, pageSize) => paginationChange(pageNum, pageSize)}
      />
    </div>
  )
}

const MemoE2damaged = React.memo(E2damaged)

export default MemoE2damaged
